# -*- coding: utf-8 -*-
"""
Lösung zu Kapitel 1.6 - Aufgabe 11 Medizintechnik

Created on Mon Jul 10 19:55:48 2023
@author: Peter Brichzin
"""
from graphics_and_games_klassen import Methodenbox

class EKG_Auswertung(Methodenbox):
    def __init__(self):
        super().__init__()
        self.daten = self.datenAusDateiLesen("EKG_Datenreihe.csv")
        self.zeitabstand = 2
        self.zeitpunkteLokalerMaxima = []
        self.lokaleMaxima = []

    def gibDatenreiheAus(self):
        for index in range(len(self.daten)):
            print(f"{index * 2} ms:   {self.daten[index]} mV")

    def zeichneMessreihe(self):
        """
        Zeichnet die gesamte Messreihe

        Returns
        -------
        None.

        """
        for index in range(len(self.daten)):
            self.zeichnePunkt(index, self.daten[index])
            # ACHTUNG: Die Verbesserung für a) muss in der 
            # Methode zeichnePunkt gesucht werden.
        

    def zeichnePunkt(self, x, y):
        """
         Methode zeichnePunkt bewegt die Turtle zu der angegebenen Position und zeichnet
         dort einen Messpunkt in Form eines Quadrats mit der Seitenlänge 2 Pixel


        Parameters
        ----------
        x : x-Wert.
        y : Da die y-Achse nach unten gerichtet ist, wird das 
            Vorzeichen des y-Werts (in der Methode geheZuPosition) invertiert.

        Returns
        -------
        None.

        """
        self.setzePosition(x , - y )

        self.senkeStift()
        for i in range(4):
            self.gehe(2)
            self.drehe(90)
        self.hebeStift()

    def bestimmeMaxSpannung(self):
        #toDo
        #toDo
        #toDo
        print("Der Maximalwert von ... mV wird erreicht zur Zeit ...ms.")

    def bestimmeMaxima(self):
        """
        Ermittelt die maximalen Spannungswerte innerhalb der QRS-Komplexe und deren Zeitpunkte 
        und speichert diese in den Attributen zeitpunkteLokalerMaxima bzw. lokaleMaxima.
   

        Returns
        -------
        None.

        """
        maximumSpannung = 0
        zeitpunktMaximum = 0
        anzahlFallendeWerte = 0

        self.zeitpunkteLokalerMaxima.clear()
        self.lokaleMaxima.clear()

        index = 0
        while index < len(self.daten):
            if self.daten[index] > 300:
                if self.daten[index] > maximumSpannung:
                    maximumSpannung = self.daten[index]
                    zeitpunktMaximum = index * self.zeitabstand
                else:
                    anzahlFallendeWerte += 1
                    if anzahlFallendeWerte > 3:
                        self.zeitpunkteLokalerMaxima.append(zeitpunktMaximum)
                        self.lokaleMaxima.append(maximumSpannung)
                        print(f"Maximum Nr. {len(self.lokaleMaxima)} bei {zeitpunktMaximum}ms / {maximumSpannung}mV")
                        index += 50
                        zeitpunktMaximum = 0
                        maximumSpannung = 0
            index += 1

    def gibHerzschlägeProMinuteAus(self):
        """
        Bestimmung der Anzahl der Herzschläge pro Minute und Ausgabe auf der Konsole


        Returns
        -------
        None.

        """
        #toDo
        #toDo
        #toDo
        print("Pro Minute schlägt das Herz ca. ... mal.")



ekg = EKG_Auswertung()
ekg.gibDatenreiheAus()
ekg.zeichneMessreihe()
ekg.bestimmeMaxSpannung()
ekg.bestimmeMaxima()
ekg.gibHerzschlägeProMinuteAus()
