# -*- coding: utf-8 -*-
"""
Lösung zu Kapitel 1.6 - Aufgabe 8 CoronaStatistik

Created on Mon Jul  3 19:55:48 2023
@author: Peter Brichzin
"""
from graphics_and_games_klassen import Methodenbox


class CoronaStatistik(Methodenbox):
    """
    Einlesen von Daten aus Dateien
    Für Teilaufgabe f müssen hier die Daten von 2021 eingelesen (und später die Skalierung verändert werden)
    Ausgabe der eingelesenen Daten
    """
    def __init__(self):
        super().__init__()
        self.neuinfizierteProTag = self.datenAusDateiLesen("NeuinfizierteProTag2020.csv")
        self.todesfälleProTag = self.datenAusDateiLesen("TodesfaelleProTag2020.csv")
        self.datenreiheAusgeben()

    def datenreiheAusgeben(self):
        """
        Ausgabe der neu Infizierten und Todesfälle pro Tag
        """
        for index in range(len(self.neuinfizierteProTag)):
            tag = index + 1
            neu_infizierte = self.neuinfizierteProTag[index]
            todesfälle = self.todesfälleProTag[index]
            print(f"Tag: {tag} neu Infizierte: {neu_infizierte} Todesfälle: {todesfälle}")

    def zeichneKoordinatensystem(self):
        """
        Methode zeichneKoordinatensystem zeichnet ein Koordinatensystem
        Beachte: In Abweichung zur Aufgabenstellung d) ist die Skalierung der Achsen ausreichend. 
        Eine Beschriftung ist in Python schwer umsetzbar, deshalb wird darauf verzichtet.
        """
        
        self.setzeFarbe("schwarz")
        
        # x-Achse
        SkalierungXAchse = 30  # senkrechter Strich alle 30 Einheiten -> ca. 1 Monat
        self.setzePosition(50, 500)  # Ursprung
        self.setzeRichtung(0)
        self.senkeStift()
        self.gehe(400)
        self.hebeStift()
        self.setzePosition(50, 500)
        for i in range(1, 400 // SkalierungXAchse + 1):
            self.setzePosition(50 + i * SkalierungXAchse, 500)
            self.zeichneMasseinheit()

        # y-Achse
        SkalierungYAchse = 50  # senkrechter Strich alle 50 Einheiten
        self.setzePosition(50, 500)
        self.setzeRichtung(90)
        self.senkeStift()
        self.gehe(450)
        self.setzePosition(50, 500)
        for i in range(1, 450 // SkalierungYAchse + 1):
            self.setzePosition(50, 500 - i * SkalierungYAchse)
            self.zeichneMasseinheit()

    def zeichneMasseinheit(self):
        """
        Hilfsfunktion zum Einzeichnen der Skala auf den Koordinatenachsen
        """
        self.hebeStift()
        self.drehe(-90)
        self.gehe(10)
        self.drehe(180)
        self.senkeStift()
        self.gehe(20)
        self.hebeStift()
        self.gehe(10)
        self.drehe(90)

    

    def zeichneNeuinfizierte(self):
        """
        toDo
        Hinweise
        über die Methode setzePosition(xNeu, yNeu) kann die Turtle bewegt werden
        beachte der Koordinatenursprung liegt bei (50, 500) und die y-Werte auf der Zeichenfläche nehmen nach unten zu 
        Ein Messpunkt kann z. B. durch Zeichnen eines Quadrats mit der Seitenlänge 2 Pixel gezeichnet werden
        über setzeFarbe(farbeNeu) kann die Farbe durch Eingabe eine Zeichenkette wie "rot" oder "blau" verändert werden
        """

    def zeichneTodesfaelle(self):
        """
        toDo
        """
        

    # Bestimmt den Maximalwert der Messreihe und gibt ihn aus    
    def maximumNeuinfizierteBestimmen(self):
        """
        toDo
        """


c= CoronaStatistik()
c.zeichneKoordinatensystem()
c.zeichneNeuinfizierte()
c.zeichneTodesfaelle()
c.maximumNeuinfizierteBestimmen()
